export default class AsyncQueue {
    dataQueue = [];
    resolve = undefined;
    promise = new Promise((resolve) => (this.resolve = resolve));
    isDone = false;
    async *[Symbol.asyncIterator]() {
        while (true) {
            if (this.dataQueue.length) {
                yield this.dataQueue.shift();
            }
            else if (this.isDone) {
                break;
            }
            else {
                await this.promise;
            }
        }
    }
    push(value) {
        this.dataQueue.push(value);
        this.resolve?.();
        this.promise = new Promise((resolve) => (this.resolve = resolve));
    }
    done() {
        this.isDone = true;
        this.resolve?.();
    }
    get size() {
        return this.dataQueue.length;
    }
}
//# sourceMappingURL=AsyncQueue.js.map